// @(#)$Id: ListExamplesProblem.scala,v 1.1 2005/10/28 09:03:35 leavens Exp leavens $
package scalahw;
trait ListExamplesProblem {
  /** Delete all elements of a list matching e.
   * This is done as a for-comprehension. */
  def delete_all[T](e: T, xs: List[T]): List[T];

  /** Delete all elements of a list matching e.
   * Using library functions. */
  def delete_all_b[T](e: T, xs: List[T]): List[T];
    
  /** Delete all elements of a list matching e.
   * Using explicit recursion and pattern matching. */
  def delete_all_c[T](e: T, xs: List[T]): List[T];
}
