// @(#)$Id: ListExamplesTest.scala,v 1.1 2005/10/28 09:03:35 leavens Exp leavens $
package scalahw;

import ListExamples._;
import testing._;

/** Testing for List examples.
 * @author Gary T. Leavens
 */
object ListExamplesTest with ConsoleTestRunner {

  /** The actual tests to run. */    
  val suite = new TestSuite(
    new Expect("delete_all(3, Nil)", 
      delete_all(3, Nil), Nil),
    new Expect("delete_all(3, List(3,4,3))", 
      delete_all(3, List(3,4,3)), List(4)),
    new Expect("delete_all(3, List(1,2,3))", 
      delete_all(3, List(1,2,3)), List(1,2)),
    new Expect("delete_all(1, List(1, 2, 3, 2, 1, 2, 3, 2, 1))", 
      delete_all(1, List(1, 2, 3, 2, 1, 2, 3, 2, 1)),
      List(2, 3, 2, 2, 3, 2)),

    // tests for delete_all_b
    new Expect("delete_all_b(3, Nil)", 
      delete_all_b(3, Nil), Nil),
    new Expect("delete_all_b(3, List(3,4,3))", 
      delete_all_b(3, List(3,4,3)), List(4)),
    new Expect("delete_all_b(3, List(1,2,3))", 
      delete_all_b(3, List(1,2,3)), List(1,2)),
    new Expect("delete_all_b(1, List(1, 2, 3, 2, 1, 2, 3, 2, 1))", 
      delete_all_b(1, List(1, 2, 3, 2, 1, 2, 3, 2, 1)),
      List(2, 3, 2, 2, 3, 2)),

    // tests for delete_all_c
    new Expect("delete_all_c(3, Nil)", 
      delete_all_c(3, Nil), Nil),
    new Expect("delete_all_c(3, List(3,4,3))", 
      delete_all_c(3, List(3,4,3)), List(4)),
    new Expect("delete_all_c(3, List(1,2,3))", 
      delete_all_c(3, List(1,2,3)), List(1,2)),
    new Expect("delete_all_c(1, List(1, 2, 3, 2, 1, 2, 3, 2, 1))", 
      delete_all_c(1, List(1, 2, 3, 2, 1, 2, 3, 2, 1)),
      List(2, 3, 2, 2, 3, 2))
    );
}
