// $Id: UProgTest.scala,v 1.1 2005/10/28 20:46:16 leavens Exp leavens $
package interp;

import Domains._;
import scala.testing.SUnit.TestCase;
import testing.Expect;

/** Test program without parsing. */
class UProgTest(code: String, prog: Program, res: ExpressedValue)
      extends TestCase(code)
{
  /** The interpreter. */
  private val interpreter = new Interpreter();
  
  /** Delegee, an instance of UProgTest. */
  private val test = new Expect(code, interpreter.evalProgram(prog), res);

  override def runTest(): Unit = test.runTest();
}
